<?php
// namespace administrator\components\com_jfbchat\controllers;
/**
 *
 * @package FBCHAT::AGENTS::administrator::components::com_jfbchat
 * @subpackage controllers
 * @author 2Punti - Marco Biagioni
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
jimport ( 'joomla.application.component.controller' );

/**
 * Agents controller responsibilities contract
 *
 * @package FBCHAT::AGENTS::administrator::components::com_jfbchat
 * @subpackage controllers
 * @since 1.0
 */
interface IAgentsController {

	/**
	 * @access public
	 */
	public function toggleState();
}


/**
 * Agents controller concrete implementation
 *
 * @package FBCHAT::AGENTS::administrator::components::com_jfbchat
 * @subpackage controllers
 * @since 1.0
 */
class JfbchatControllerAgents extends jfbcController implements IAgentsController {

	/**
	 * Default listEntities
	 * 
	 * @access public
	 * @return void
	 */
	public function display() {
		// Get app, vars and set model state 
		$app = JFactory::getApplication();
		$option= JRequest::getVar('option');
		$limit = $app->getUserStateFromRequest("$option.agents.limit", 'limit', $app->getCfg('list_limit'), 'int') ;
		$limitStart = $app->getUserStateFromRequest("$option.agents.limitstart", 'limitstart', 0, 'int') ;
		$search = $app->getUserStateFromRequest("$option.agents.searchword", 'search', null) ;
		$filter_type = $app->getUserStateFromRequest( "$option.agents.filter_type", 'filter_type', null );
		$filter_order = $app->getUserStateFromRequest( "$option.agents.filter_order", 'filter_order', 'a.name', 'cmd' );
		$filter_order_Dir = $app->getUserStateFromRequest( "$option.agents.filter_order_Dir", 'filter_order_Dir', 'ASC', 'word' );
		// Get default model
		$defaultModel = $this->getModel();
		// Set model state
		$defaultModel->setState('limit', $limit);
		$defaultModel->setState('limitstart', $limitStart);
		$defaultModel->setState('searchword', $search);
		$defaultModel->setState('filter_type', $filter_type);
		$defaultModel->setState('order', $filter_order);
		$defaultModel->setState('order_dir', $filter_order_Dir);
		$defaultModel->setState('option', $option);
		
		// Parent construction and view display
		parent::display();
	}

	/**
	 * @access public
	 * @return void
	 */
	public function toggleState() {
		$cid = JRequest::getVar('cid', array(0), 'method', 'array');
		$idEntity = (int) $cid[0];
		$model = $this->getModel();
		$result = $model->changeAgentState($idEntity, $this->task);
		$msg = null;
		if ($result) {
			$msg = JText::_('AGENT_STATE_CHANGED');
		}
		$this->setRedirect( 'index.php?option=com_jfbchat&task=agents.display', $msg);
	}
	
	/**
	 * Class constructor
	 * @return Object&
	 */
	public function __construct($config = array()){
		parent::__construct($config);
		
		$this->registerTask('makeagent', 'toggleState');
		$this->registerTask('destroyagent', 'toggleState'); 
	}
}
?>