<?php
// namespace administrator\components\com_jfbchat\controllers;
/**
 *
 * @package FBCHAT::LICENSE::administrator::components::com_jfbchat
 * @subpackage controllers
 * @author 2Punti - Marco Biagioni
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
jimport ( 'joomla.application.component.controller' );

/**
 * License controller interface
 *
 * @package FBCHAT::LICENSE::administrator::components::com_jfbchat
 * @subpackage controllers
 * @since 1.0
*/
interface ILicenseController {
	/**
	 * Esegue la Remote API CALL e aggiorna la licenza d'uso
	 *
	 * @access public
	 * @return void
	 */
	public function updateLicense();
}

/**
 * License controller implementation
 *
 * @package FBCHAT::LICENSE::administrator::components::com_jfbchat
 * @subpackage controllers
 * @since 1.0
 */
class JfbchatControllerLicense extends jfbcController implements ILicenseController {
	/**
	 * Mostra info e license updating form
	 *
	 * @access public
	 * @return void
	 */
	public function display() {
		parent::display ();
	}

	/**
	 * Esegue la Remote API CALL e aggiorna la licenza d'uso
	 *
	 * @access public
	 * @return void
	 */
	public function updateLicense() { 
		// Get entity type
		$codeTypeDc = JRequest::getVar('codesubmitdc', null);
		$codeType = $codeTypeDc ? 'codesubmitdc' : 'codesubmitexp';

		$model = $this->getModel();
		$resultMessage = $model->storeEntity($codeType);
			
		$this->setRedirect( 'index.php?option=com_jfbchat&task=license.display', $resultMessage);
	}
}