<?php
// namespace administrator\components\com_jfbchat\controllers;
/**
 *
 * @package FBCHAT::MESSAGES::administrator::components::com_jfbchat
 * @subpackage controllers
 * @author 2Punti - Marco Biagioni
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
jimport ( 'joomla.application.component.controller' );

/**
 * User messages controller responsibilities contract
 *
 * @package FBCHAT::MESSAGES::administrator::components::com_jfbchat
 * @subpackage controllers
 * @since 1.0
 */
interface IMessagesController {

	/**
	 * Mostra il dettaglio dell'entity
	 * 
	 * @access public
	 * @return void
	 */
	public function showEntity();
	
	/**
	 * Avvia il processo di esportazione records
	 *
	 * @access public
	 * @return void
	 */
	public function exportMessages();
}

/**
 * User messages concrete implementation
 *
 * @package FBCHAT::MESSAGES::administrator::components::com_jfbchat
 * @subpackage controllers
 * @since 1.0
 */
class JfbchatControllerMessages extends jfbcController implements IMessagesController { 
	/**
	 * Setta il model state a partire dallo userstate di sessione
	 * @access protected
	 * @return void
	 */
	protected function setModelState() {
		parent::setModelState('messages');
		
		// User state specific
		$app = JFactory::getApplication();
		$option= JRequest::getVar('option');
		  
		$fromPeriod = $app->getUserStateFromRequest( "$option.messages.fromperiod", 'fromperiod');
		$toPeriod = $app->getUserStateFromRequest( "$option.messages.toperiod", 'toperiod');
		$msgType = $app->getUserStateFromRequest( "$option.messages.msg_type", 'msg_type');
		
		// Get default model
		$defaultModel = $this->getModel();
		
		// Set model state  
		$defaultModel->setState('fromPeriod', $fromPeriod);
		$defaultModel->setState('toPeriod', $toPeriod);
		$defaultModel->setState('msgType', $msgType);
	}
	
	/**
	 * Default listEntities
	 * 
	 * @access public
	 * @return void
	 */
	public function display() {
		// Set model state 
		$this->setModelState();
		
		// Parent construction and view display
		parent::display();
	}

	/**
	 * Mostra il dettaglio dell'entity
	 * 
	 * @access public
	 * @return void
	 */
	public function showEntity() {
		$cid = JRequest::getVar('cid', array(0), 'method', 'array');
		$idEntity = (int) $cid[0];
		$model = $this->getModel();
		$record = $model->loadEntity($idEntity);
		
		$model->setState('option', JRequest::getVar('option'));
 
		$view = $this->getView();
		$view->setModel ( $model, true );
		$view->showEntity($record); 
	}
	
	/**
	 * Cancella una entity dal DB
	 *
	 * @access public
	 * @return void
	 */
	public function deleteEntity() {
		$cids = JRequest::getVar('cid', array(0), 'method', 'array');
		$option = JRequest::getVar('option');
		//Load della  model e checkin before exit
		$model = $this->getModel ( );
		$result = $model->deleteEntity($cids);
	
		$msgResult = $result ? 'MSG_SUCCESS_DELETE' : 'MSG_ERROR_DELETE';
			
		$this->setRedirect ( "index.php?option=$option&task=messages.display", JTEXT::_($msgResult) );
	}
	
	/**
	 * Avvia il processo di esportazione records
	 *
	 * @access public
	 * @return void
	 */
	public function exportMessages() { 
		// Set model state 
		$this->setModelState();
		// Mapping fields to load to column header
		$fieldsToLoadArray = array(	'a.sender_name'=>JText::_('SENDER_NAME'),
				'a.receiver_name'=>JText::_('RECEIVER_NAME'),
				'a.session_id_from'=>JText::_('SESSION_ID_FROM'),
				'a.session_id_to'=>JText::_('SESSION_ID_TO'),
				'a.message'=>JText::_('MESSAGE'),
				'a.sent'=>JText::_('SENT'),
				'a.read'=>JText::_('READ'),
				'a.type'=>JText::_('TYPE')); 
		$fieldsFunctionTransformation = array();
		
		$model = $this->getModel();
		$data = $model->exportMessages($fieldsToLoadArray, $fieldsFunctionTransformation);
		
		if(!$data) {
			$this->setRedirect('index.php?option=com_jfbchat&task=messages.display', JText::_('NODATA_EXPORT'));
			return false;
		}
		
		// Get view
		$view = $this->getView();
		$view->sendCSVMessages($data, $fieldsFunctionTransformation);
	}  
}
?>