<?php
// namespace administrator\components\com_jfbchat\tables;
/**
 *
 * @package FBCHAT::MESSAGES::administrator::components::com_jfbchat
 * @subpackage tables
 * @author 2Punti - Marco Biagioni
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
jimport ( 'joomla.application.component.model' );

/**
 * Messages table
 *
 * @package FBCHAT::MESSAGES::administrator::components::com_jfbchat
 * @subpackage tables
 * @since 1.0
 */
class TableLamessages extends JTable {
	/**
	 * @var int Primary key
	 */
	var $id = null;
	/**
	 * @var string
	 */
	var $name = null;
	/**
	 * @var string
	 */
	var $email = null;
	/**
	 * @var string
	 */
	var $message = null;
	/**
	 * @var string
	 */
	var $sentdate = null;
	/**
	 * @var int
	 */
	var $userid = null;
	/**
	 * @var string
	 */
	var $worked = null; 
	/**
	 * @var string
	 */
	var $responses = array();
	
	/**
	 * Loads a row from the database and binds the fields to the object properties
	 *
	 * @override
	 * @access	public
	 * @param	mixed	Optional primary key.  If not specifed, the value of current key is used
	 * @return	boolean	True if successful
	 */
	function load( $oid=null ) {
		// Parent std load
		parent::load($oid);
		
		// Unserialize campo risposte/data
		if($this->responses) {
			$this->responses = unserialize($this->responses);
		} else {
			// Init qui
			$this->responses = array();
		}
		
		// Foreign key management
		$usersTable = JTable::getInstance('user');
		
		// Foreign key mapping #__users
		if($usersTable->load($this->userid)) {
			$this->_username_logged = $usersTable->name;
		} 
		
		return true;
	}
	
	/**
	 * Binds a named array/hash to this object
	 *
	 * @override 
	 * @access	public
	 * @param	mixed	Optional primary key.  If not specifed, the value of current key is used
	 * @param boolean $storeResponse
	 * @return	boolean	True if successful
	 */
	function bind( $from, $ignore=array(), $storeResponse = false ) {
		// Parent std load
		parent::bind( $from, $ignore=array() );
	
		// Unserialize campo risposte/data
		if(is_array($this->responses) && $storeResponse) {  
			$this->responses[] = array(date('Y-m-d H:i:s'), $from['response']); 
			$this->responses = serialize($this->responses);
		}
	 
		return true;
	}
	
	/**
	 *
	 * @param
	 *        	database A database connector object
	 */
	function __construct(&$db) {
		parent::__construct ( '#__fbchat_lamessages', 'id', $db );
	}
}