<?php
// namespace administrator\components\com_jfbchat\views\cpanel;
/**
 *
 * @package FBCHAT::CPANEL::administrator::components::com_jfbchat
 * @subpackage views
 * @subpackage cpanel
 * @author 2Punti - Marco Biagioni
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' ); 

/**
 * CPanel view
 *
 * @package FBCHAT::CPANEL::administrator::components::com_jfbchat
 * @subpackage views
 * @subpackage cpanel
 * @since 1.0
 */
class JfbchatViewCpanel extends JViewLegacy { 
	/**
	 * Renderizza l'iconset del cpanel
	 *
	 * @param $link string       	
	 * @param $image string       	
	 * @access private
	 * @return string
	 */
	private function getIcon($link, $image, $text) {
		$mainframe = JFactory::getApplication ();
		$lang = & JFactory::getLanguage ();
		?>
<div style="float:<?php echo ($lang->isRTL()) ? 'right' : 'left'; ?>;">
	<div class="icon">
		<a href="<?php echo $link; ?>">
					<img src="components/com_jfbchat/images/<?php echo $image;?>" />
					<span><?php echo $text; ?></span>
		</a>
	</div>
</div>
<?php
	}
	
	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addDisplayToolbar() { 
		JToolBarHelper::title( JText::_( 'CPANEL' ), 'jfbchat' );
		JToolBarHelper::custom('cpanel.display', 'config', 'config', 'CPANEL', false);
	}
	
	/**
	 * Effettua il rendering del pannello di controllo
	 * @access public
	 * @return void
	 */
	public function display() { 
		$app = JFactory::getApplication();
		$template = $app->getTemplate();
		$imgsPath = 'templates/' . $template . '/images/admin/';
		$doc = JFactory::getDocument ();
		$doc->addStylesheet ( JURI::root ( true ) . '/administrator/components/com_jfbchat/css/cpanel.css' );
		$doc->addStylesheet ( JURI::root ( true ) . '/administrator/components/com_jfbchat/css/license.css' );
		// Buffer delle icons
		ob_start ();
		$this->getIcon ( 'index.php?option=com_jfbchat&task=agents.display', 'icon-48-groups.png', JText::_ ( 'AGENTS' ) );
		$this->getIcon ( 'index.php?option=com_jfbchat&task=messages.display', 'icon-48-readmess.png', JText::_ ( 'MESSAGES' ) );
		$this->getIcon ( 'index.php?option=com_jfbchat&task=lamessages.display', 'icon-48-writemess.png', JText::_ ( 'LAMESSAGES' ) );
		$this->getIcon ( 'index.php?option=com_jfbchat&task=realstats.display', 'icon-48-realstats.png', JText::_ ( 'REALSTATS' ) );
		$this->getIcon ( 'index.php?option=com_jfbchat&task=serverstats.display', 'icon-48-stats.png', JText::_ ( 'SERVERSTATS' ) );
		$this->getIcon ( 'index.php?option=com_jfbchat&task=suggestions.display', 'icon-48-help-forum.png', JText::_ ( 'SUGGESTIONS' ) );
		$this->getIcon ( 'index.php?option=com_jfbchat&task=license.display', 'icon-48-links.png', JText::_ ( 'LICENSE' ) );
		$this->getIcon ( 'index.php?option=com_jfbchat&task=config.display', 'icon-48-config.png', JText::_ ( 'CONFIG' ) );
		$contents = ob_get_clean ();
		
		// Model Data 
		$licenseData = $this->get ( 'Data', 'license' ); 
		// Assign reference variables
		$this->assignRef ( 'icons', $contents ); 
		$this->assignRef ( 'licensedata', $licenseData );
		$this->assignRef ( 'componentParams', JComponentHelper::getParams('com_jfbchat') );
		$this->assignRef ( 'imgpath', $imgsPath);
		
		// Aggiunta toolbar
		$this->addDisplayToolbar();
		// Output del template
		parent::display ();
	}
	

}
?>