<?php
// namespace administrator\components\com_jfbchat\views\messages;
/** 
 * @package FBCHAT::SUGGESTIONS::administrator::components::com_jfbchat
 * @subpackage views
 * @subpackage messages
 * @author 2Punti - Marco Biagioni
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );    
jimport('joomla.html.pagination');

/**
 * Suggestions messages view contract
 *
 * @package FBCHAT::SUGGESTIONS::administrator::components::com_jfbchat
 * @subpackage views
 * @subpackage messages
 * @since 1.0
 */
interface ISuggestionsView { 
	/**
	 * Editing dettaglio del record singolo
	 * @param Object& $row
	 * @access public
	 */
	public function editEntity(&$row); 
}

/**
 * Suggestions view implementation
 *
 * @package FBCHAT::MESSAGES::administrator::components::com_jfbchat
 * @subpackage views
 * @since 1.0
 */
class JfbchatViewSuggestions extends JViewLegacy implements ISuggestionsView {
	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addShowEntityToolbar() {
		JToolBarHelper::title( JText::_( 'SUGGESTION_DETAILS' ), 'jfbchat' );
		JToolBarHelper::apply( 'suggestions.applyEntity', 'apply');
		JToolBarHelper::save( 'suggestions.saveEntity', 'save');
		JToolBarHelper::custom('suggestions.cancelEntity', 'back', 'back', 'LIST_SUGGESTIONS', false);
	}
	
	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addDisplayToolbar() {
		JToolBarHelper::title( JText::_( 'LIST_SUGGESTIONS' ), 'jfbchat' );
		JToolBarHelper::addNew('suggestions.editentity', 'NEW_SUGGESTION');
		JToolBarHelper::editList('suggestions.editentity', 'VIEW_SUGGESTION_DETAILS');
		JToolBarHelper::deleteList(JText::_('DELETE_SUGGESTIONS'), 'suggestions.deleteentity');
		JToolBarHelper::custom('cpanel.display', 'config', 'config', 'CPANEL', false);
	}
	
	/**
	 * Default listEntities
	 * @access public
	 */
	public function display() { 
		$doc = JFactory::getDocument ();
		$doc->addStylesheet ( JURI::root ( true ) . '/administrator/components/com_jfbchat/css/generic.css' ); 
		// Get main records
		$rows = $this->get('Data'); 
		$total = $this->get('Total');
		 
		// Pagination view object model state populated
		$pagination = new JPagination( $total, $this->getModel()->getState('limitstart'), $this->getModel()->getState('limit') ); 
		 
		$this->assignRef('pagination',	$pagination); 
		$this->assignRef('items', $rows);
		$this->assignRef('option', $this->getModel()->getState('option')); 
		$this->assignRef('user', JFactory::getUser());
		
		// Aggiunta toolbar
		$this->addDisplayToolbar();
		
		// Output del template
		parent::display();
	}

	/**
	 * Mostra la visualizzazione dettaglio del record singolo
	 * @param Object& $row
	 * @access public
	 */
	public function editEntity(&$row) {  
		$doc = JFactory::getDocument ();
		$doc->addStylesheet ( JURI::root ( true ) . '/administrator/components/com_jfbchat/css/generic.css' );
		// Aggiunta toolbar
		$this->addShowEntityToolbar();
		
		$this->assignRef('option', $this->getModel()->getState('option'));
		$this->assignRef('record', $row);
		
		$this->setLayout('suggestion');
		parent::display('details');
	} 
}
?>