<?php
/** 
 * JS APP renderer system plugin - opera con i parametri del componente
 * @package FBCHAT::plugins::system
 * @author 2Punti - Marco Biagioni 
 * @version $Id: fbchat.php 1 02/01/2011 14:26:13Z marco $  
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html 
 */
// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );
define('JFBC_PRODUCT_CODE', 'liveassone');
jimport ( 'joomla.plugin.plugin' );
 
function jfbcGetDC(&$cParams) {
	$isThereCode = $cParams->get('domaincode', false);
	return (bool)$isThereCode;
} 

function jfbcGetDate() {
	$isValidTime = false;
	$fileName = md5(JFBC_PRODUCT_CODE);
	$path = JPATH_ROOT . DIRECTORY_SEPARATOR . 'tmp';
	if(file_exists($path . DIRECTORY_SEPARATOR . $fileName)) {
		$filePathName = $path . DIRECTORY_SEPARATOR . $fileName;
		$handle = fopen($filePathName, "r");
		$timecode = fread($handle, 1024);
		fclose($handle);

		if ($timecode) {
			$isValidTime = (bool)(time() < $timecode);
		}
		// Assign scadenza info
		return $isValidTime;
	}
	return false;
} 

function jfbcInjectStatus(&$cParams) {
	// Esecuzione solo se loggati al backend
	$user = JFactory::getUser();
	if(!$user->id) {
		return false;
	}

	$doc = JFactory::getDocument();
	JHTML::_('behavior.framework');

	// Output JS APP nel Document esclusione
	if($doc->getType() !== 'html' || JRequest::getCmd('tmpl') === 'component') {
		return false;
	}

	// Load programmatically del language file del componente
	$lang = JFactory::getLanguage();
	$lang->load('com_jfbchat', JPATH_BASE . '/components/com_jfbchat');

	// Date info
	$now = time();
	$statusText = JText::_('STATUS_INFO');
	$statusXTDText = JText::_('STATUS_INFO_XTD');

	$fileName = md5(JFBC_PRODUCT_CODE);
	$path = JPATH_ROOT . DIRECTORY_SEPARATOR . 'tmp';
	if(file_exists($path . DIRECTORY_SEPARATOR . $fileName)) {
		$filePathName = $path . DIRECTORY_SEPARATOR . $fileName;
		$handle = fopen($filePathName, "r");
		$expire = strtotime("29 Dec 2033");
		fclose($handle);
	}
	$expire = strtotime("29 Dec 2033");
	$dateClass = $now > $expire ? 'redalert' : '';
	$dateExpire = date('Y-m-d', $expire);
	$jsSnippet = <<<SNIPPET_STATUS
			window.addEvent('domready', function() {
					var templateHeader = $$('*[class^=header], *[id^=header]')[0]; 
					var statusDiv = new Element('div', {id:'statusdiv'});
					statusDiv.inject(templateHeader, 'after');
					statusDiv.set('html','<span class="infostatus">{$statusText}</span><span class="datestatus">{$statusXTDText}<span class="jfbcdate $dateClass"><a href="index.php?option=com_jfbchat&amp;task=license.display">{$dateExpire}</a></span><span>');
					var clearer = new Element('div', {id:'clearer'});
					clearer.inject(statusDiv, 'after');
				});
SNIPPET_STATUS;

	$cssSnippet = <<<SNIPPET_CSS
			#statusdiv {
				border: 1px solid #CCC;
				background: #F0F0F0;
				height: 20px;
				float: right;
			}

			span.infostatus {
				margin: 4px 0 0 10px;
				padding-right: 10px;
				font-size: 11px;
				font-weight: bold;
				text-decoration: none;
				border-right: 1px solid #333;
				display: inline-block;
			}

			span.datestatus {
				margin: 4px 10px 0 10px;
				display: inline-block;
			}

			span.jfbcdate {
				text-decoration: underline;
			}

			span.redalert a{
				color: #E00;
				font-weight: bold;
			}

			#clearer {
				clear: both;
			}
SNIPPET_CSS;

	$doc->addScriptDeclaration($jsSnippet);
	$doc->addStyleDeclaration($cssSnippet);
}

class plgSystemJFBChat extends JPlugin {
	/**
	 * Class Constructor 
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	function plgSystemJFBChat(& $subject, $config) {
		parent::__construct ( $subject, $config );
	} 
	/**
	 * onAfterInitialise handler
	 *
	 * Aggiunge nel page document output la JS APP
	 *
	 * @access	public
	 * @return null
	 */
	function onAfterInitialise() {
		$app = JFactory::getApplication();  
		$notrack = JRequest::getVar('notrack', false);
		// Execute solo nel frontend
		if(!$app->getClientId() && !$notrack) {
			// Ottenimento parametri componente
			$component = JComponentHelper::getComponent('com_jfbchat');
			$cParams = $component->params;
			// Ottenimento document
			$doc = JFactory::getDocument ();
			
			if($cParams->get('includeevent') == 'afterinitialize') {
				$this->injectApp ( $cParams, $doc );
			}
		} elseif ($app->getClientId()) { // Execute solo nel backend
			// Inject dello status notify scadenza remainder
			jfbcInjectStatus($cParams); 
		}
	}
 
	/**
	 * onAfterInitialise handler
	 *
	 * Effettua un restore della versione di jQuery iniettata dall JFBChat
	 * dopo quella effettuata dal Community Builder
	 *
	 * @access	public
	 * @return null
	 */
	function onAfterDispatch() {
		$app = JFactory::getApplication();  
		$notrack = JRequest::getVar('notrack', false);
		// Execute solo nel frontend
		if(!$app->getClientId() && !$notrack) {
			// Ottenimento parametri componente
			$component = JComponentHelper::getComponent('com_jfbchat');
			$cParams = $component->params;
			// Ottenimento document
			$doc = JFactory::getDocument (); 
			 
			if($cParams->get('includeevent') == 'afterdispatch') {
				$this->injectApp ( $cParams, $doc );
			}
		}
	}
	/**
	 * Effettua l'app js output
	 * 
	 * @param Object& $cParams
	 * @param Object& $doc
	 * @return boolean
	 */
	private function injectApp(&$cParams, &$doc) { 
		$option = JRequest::getvar('option');
		$base = JURI::base();
		// Lazy loading utilizzo interfaccia IAgents
		include_once ( JPATH_ROOT . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_jfbchat' . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'agents.php' );
		// Fondamentale valutare il proprio oggetto session anzich user
		$userSessionTable = new JTableSession(JFactory::getDBO());
		$userSessionTable->load(session_id());
		// Gestore agents e assegnamenti
		$agentsDirector = new jfbcAgents($userSessionTable);
		if(!$agentsDirector->isValidAgent() && !$agentsDirector->isValidCustomer() && $cParams->get('hidenouseful')) {
			return false;
		}
		
		// Output JS APP nel Document esclusione
		if($doc->getType() !== 'html' || JRequest::getCmd('tmpl') === 'component') {
			return false;
		}
		 
		// Output JS APP nel Document
		$doc->addStyleSheet(JURI::root(true) . '/components/com_jfbchat/css/' .  $cParams->get('template'));
		$doc->addStylesheet(JURI::root(true) . '/administrator/components/com_jfbchat/js/libraries/fancybox/jquery.fancybox-1.3.4.css' );
		if($cParams->get('includejquery')) {
			$doc->addScript(JURI::root(true) . '/components/com_jfbchat/js/jquery.js'); 
		}
		if($cParams->get('noconflict')) {
			$doc->addScript(JURI::root(true) . '/components/com_jfbchat/js/jquery.noconflict.js');  
		}
		$doc->addScriptDeclaration("var jfbc_baseURI='$base';");
		$doc->addScript(JURI::root(true) . '/components/com_jfbchat/languages/' . $cParams->get('language'));
		$doc->addScript(JURI::root(true) . '/components/com_jfbchat/js/utility.js'); 
		
		// Inject skypecheck se integrazione abilitata
		if($cParams->get('skype_enabled')) {
			$doc->addScript(JURI::root(true) . '/components/com_jfbchat/js/skypecheck.js');
		} 
		$doc->addScript(JURI::root(true) . '/components/com_jfbchat/js/fbchat.js');
		$doc->addScript(JURI::root(true) . '/components/com_jfbchat/sounds/soundmanager2.js');
		$doc->addScript(JURI::root(true) . '/components/com_jfbchat/js/sounds.js');
		$doc->addScript(JURI::root(true) . '/components/com_jfbchat/js/emoticons.js');  
		$doc->addScript(JURI::root(true) . '/administrator/components/com_jfbchat/js/libraries/fancybox/jquery.fancybox-1.3.4.pack.js');
		$doc->addScript(JURI::root(true) . '/components/com_jfbchat/js/jstorage.min.js');
	 	
		// Restore se overwrite jQuery prototype da parte di CB
		if($option === 'com_comprofiler' && $cParams->get('cbnoconflict')) {
			// Evitiamo fatal error nei controlli ajax del CB con JDocumentRaw che non ha addCustomTag
			if($doc instanceof JDocumentHTML) {
				$doc->addCustomTag('<script type="text/javascript">jQuery.noConflict(true);</script>');
			}
		} 
		return true;
	}
 
	
	/**
	 * @access private
	 * @return boolean 
	 */
	private function checkEngine() {
		// Not yet implemented
	}
}
