<?php
//namespace components\com_jfbchat;
/**
 * Sender dei messaggi 
 * @package FBCHAT::DATA::components::com_jfbchat 
 * @subpackage controllers
 * @author 2Punti - Marco Biagioni
 * @version $Id: sender.php 54 15/01/2012 15:30:40Z marco $     
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html  
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
require_once JPATH_COMPONENT . '/models/sender.php';
jimport('joomla.database.table.session');
 
//Inizializzazione variabili CGI
$status = JRequest::getVar('status', null);
$statusmessage = JRequest::getVar('statusmessage', null);
$skypeFields= JRequest::getVar('skypefields', null);
$overridename = JRequest::getVar('overridename', null);
$message = JRequest::getVar('message', null, 'default', 'none', JREQUEST_ALLOWHTML );
$message = strip_tags($message, '<img>,<br>,<a>'); 
$to = JRequest::getVar('to');
$lamMessage = JRequest::getVar('lam_insert_message', false, 'default', 'bool');
$sessionActiveChatBoxes = JRequest::getVar('sessionActiveChatBoxes', false);
 
// Fondamentale valutare il proprio oggetto session anzich user
// Istanzazione con Dependency injection
$session = new JTableSession(JFactory::getDBO());
$session->load(session_id());
$fbchatSenderModel = new jfbcSender($session);
 
/*
 * Pseudo logic controller in base alla HTTP POST params senza method dispatch esplicito
 */

//Settaggio status dell'utente
if (!empty($status)) { 
	$response = $fbchatSenderModel->insertStatus($status);
}

//Settaggio messaggio status personalizzabile da keyevent 'invio' dal campo testo
if (!empty($statusmessage)) { 
	$response = $fbchatSenderModel->insertStatusMsg($statusmessage);
}

//Settaggio messaggio status personalizzabile da keyevent 'invio' dal campo testo
if (!empty($skypeFields)) {
	$response = $fbchatSenderModel->insertSkypeFields(JRequest::getVar('field', null));
}

//Settaggio override name se utente guest AKA loggedout = 1
if (!empty($overridename)) {
	$response = $fbchatSenderModel->insertOverrideName($overridename);
}
 
//Inserimento nuovi messaggi
if (!empty($to) && !empty($message)) {  
	$fromName = JRequest::getVar('fromname', null);
	$toName = JRequest::getVar('toname', null);
	$response = $fbchatSenderModel->insertMessage($message, $to, $fromName, $toName);
}

//Immediate refresh delle activeChatboxes
if(!empty($sessionActiveChatBoxes)) { 
	$response = $fbchatSenderModel->resfreshActiveChatBoxes($sessionActiveChatBoxes);
}

//Inserimento LAM message
if($lamMessage) {
	$formData = array();
	$formData['name'] = JRequest::getVar('lam_ajax_name', null);
	$formData['email'] = JRequest::getVar('lam_ajax_email', null);
	$formData['message'] = JRequest::getVar('lam_ajax_message', null);
	$response = $fbchatSenderModel->insertLamessage($formData);
}

// JS Domain response
if($response) {
	echo $response;
	exit();
}