<?php
//namespace components\com_jfbchat\models; 
/** 
 * @package FBCHAT::FILES::components::com_jfbchat
 * @subpackage models
 * @author 2Punti - Marco Biagioni   
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html  
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.filesystem.file');
/**
 * Permette la gestione degli avatar personalizzati permettendone l'upload e la cancellazione,
 * nonch la visualizzazione renderizzata in un iframe popup da javascript side
 * @package FBCHAT::FILES::components::com_jfbchat
 * @subpackage models
 * @since 1.0
 */ 
class jfbcMsgFile {
	/**
	 * DB object connector
	 * @access private
	 * @var Object
	 */
	private $DBO;
	
	/**
	 * Sender user session ID
	 * @access private
	 * @var string
	 */
	private $from;
	
	/**
	 * Receiver user session ID
	 * @access private
	 * @var string
	 */
	private $to;
	
	/**
	 * Receiver user session ID
	 * @access private
	 * @var string
	 */
	private $senderName;
	
	/**
	 * Receiver user session ID
	 * @access private
	 * @var string
	 */
	private $receiverName;
	
	/**
	 * Plugin configuration object
	 * @access private
	 * @var Object
	 */
	private $config;
	 
	
	/**
	 * Path della cache folder per i files
	 * @access private
	 * @var int
	 */
	private $cacheFolder;
	
	/**
	 * Genera l'hash del filename su cui operare sulla base del filename e dell'id
	 * dell'utente che invia il file in upload
	 * @access private
	 * @param string $filename
	 * @param string $userSessionID
	 * @return string 
	 */
	private function generaHash($filename, $userSessionID) { 
		$filenameStripped = JFile::stripExt($filename); 
		$fileExtension = JFile::getExt($filename);
		 
		$hash = md5($filenameStripped . $userSessionID);
		return $hash . '.' . $fileExtension;
	}
	
	/**
	 * Genere l'hash del filename su cui operare
	 * @access private
	 * @param string $filename
	 * @return boolean 
	 */
	private function storeDBMessage($filename) { 
		if (!empty($this->to) && !empty($filename)) {   
			$sql = "INSERT INTO #__fbchat (" .
					$this->DBO->quoteName('session_id_from') . ',' .
					$this->DBO->quoteName('session_id_to') . ',' .
					$this->DBO->quoteName('message') . ',' .
					$this->DBO->quoteName('sent') . ',' .
					$this->DBO->quoteName('read') . ',' .
					$this->DBO->quoteName('type') . ',' .
					$this->DBO->quoteName('status') . ',' . 
					$this->DBO->quoteName('sender_name') . ',' . 
					$this->DBO->quoteName('receiver_name') . ') VALUES( ' . 
					$this->DBO->Quote($this->from). ", ".
					$this->DBO->Quote($this->to). ",".
					$this->DBO->Quote($filename) . 
					",UNIX_TIMESTAMP(NOW()),0,'file',0," .
					$this->DBO->Quote($this->senderName) . ",".
					$this->DBO->Quote($this->receiverName) . ")";
		    $this->DBO->setQuery($sql);
			if(!$this->DBO->execute()){
				return false;
			} 
			
			// Storing in sessione
			if (empty($_SESSION['jfbcchat_user_'.$this->to])) {
				$_SESSION['jfbcchat_user_'.$this->to] = array();
			}
			//Memorizziamo in sessione locale mittente il messaggio inviato al to destinatario
			 $_SESSION['jfbcchat_user_'.$this->to][] = array("id" => $this->DBO->insertid(), 
															 "from" => $this->to, 
															 "message" => $filename, 
				 											 "type" => 'file',
								 							 "status" => 0,
															 "self" => 1, 
															 "old" => 1) ; 
		}
		return true;
	}

	/**
	 * Legge e invia nello stream di output i contenuti del file in chunk,
	 * ovviando ai problemi di limiti legati alla normale readfile
	 * @access private
	 * @param string $nomefile
	 * @return boolean
	 */
	private function readFileChunked($filePath) {
		$chunksize = 1 * (1024 * 1024); // how many bytes per chunk
		$buffer = '';
		$cnt = 0;
		$handle = fopen ( $filePath, 'rb' );
		if ($handle === false) {
			return false;
		}
		while ( ! feof ( $handle ) ) {
			$buffer = fread ( $handle, $chunksize );
			echo $buffer;
			@ob_flush ();
			flush ();
		}
		$status = fclose ( $handle );
		return $status;
	}
	
	/**
	 * Ottiene il mime-type del file basandosi sull'estensione in modo indipendente
	 * dal sistema, dalle estensioni caricate e dalla disponibilit di fileinfo
	 * @access private
	 * @param $filename
	 * @return string Il mime type trovato a fronte del lookup nella tabella
	 */
	private function detectMimeType($filename) {
		global $mosConfig_absolute_path;
		require_once 'components' . DIRECTORY_SEPARATOR . 'com_jfbchat' . DIRECTORY_SEPARATOR . 'libraries' . DIRECTORY_SEPARATOR . 'mime.mapping.php';
		
		$filename = strtolower ( $filename );
		$exts = explode ( "[/\\.]", $filename );
		$n = count ( $exts ) - 1;
		$fileExtension = $exts [$n];
		
		foreach ( $mime_extension_map as $extension => $mime ) {
			if ($extension === $fileExtension)
				return $mime;
		}
		return 'application/octet-stream';
	}
	
	/**
	 * Mostra i due form utente se supportato dal browser l'invio secondo XHR2
	 * altrimenti si limita a visualizzare quello di default con multipart/form-data
	 * @access public
	 * @param string $msg Eventuale messaggio informativo utente
	 * @return void 
	 */
	public function showForms($msg = null) { 
		$baseUri = JURI::base(); 
		$language = $this->config->get('language');
		$template = $this->config->get('template');
		$maxFileSize = $this->config->get('maxfilesize');
		$disallowedExt = json_encode(explode(',', $this->config->get('disallowed_extensions')));
		$uploadForm = <<<UPLOADFORM
		<script type="text/javascript">
			var jfbc_baseURI = '$baseUri';
		 	var jfbc_max_filesize = $maxFileSize;
		 	var jfbc_not_allowed_ext = $disallowedExt;
		</script>
		<script type="text/javascript" src="{$baseUri}components/com_jfbchat/languages/$language" charset="utf-8"></script>
		<script type="text/javascript" src="{$baseUri}components/com_jfbchat/js/jquery.js"></script>
		<script type="text/javascript" src="{$baseUri}components/com_jfbchat/js/files.js"></script>
		<link type="text/css" rel="stylesheet" href="{$baseUri}components/com_jfbchat/css/$template"/>
		<form name="uploadform" enctype="multipart/form-data" id="uploadform" method="post" action="index.php">
			<input type="file" id="fileinput" name="newfile" />
			<div class="upload_usermessage">$msg</div>
			<div class="clr"></div>
			<div class="formbutton">
				<input id="file_upload_button" type="submit" value="" />
				<script>$('#file_upload_button').val(jfbc_upload);</script>
			</div>
			<input type="hidden" name="option" value="com_jfbchat" />
			<input type="hidden" name="controller" value="msgfile" />
			<input type="hidden" name="task" value="doUpload" />
			<input type="hidden" name="format" value="raw" />
			<input type="hidden" name="to" value="$this->to" />
			<input type="hidden" name="fromUserName" value="$this->senderName" />
			<input type="hidden" name="toUserName" value="$this->receiverName" />
		</form> 
		<div class="dragdrop_title"><script>document.write(jfbc_usednd);</script></div>
		<div id="fileDrop">
                <p><script>document.write(jfbc_drophere);</script></p>
		</div> 
		<div id="files"> 
                <ul id="fileList"></ul> 
     	</div>
		<div class="xhr2_resetbutton"><a id="reset" href="javascript:void(0);" title="Remove all files from list"><script>document.write(jfbc_clearlist);</script></a></div>
		<div class="xhr2_uploadbutton"><a id="upload" href="javascript:void(0);" title="Upload"><script>document.write(jfbc_xhr2upload);</script></a></div>
UPLOADFORM;
		 echo $uploadForm; 
	}

	/**
	 * Effettua l'upload del file classico da array superglobale $_FILES
	 * @access public
	 * @return void 
	 */
	public function doUpload() {
		// Recupera il file in upload 
		$tmpFile = $_FILES['newfile']['tmp_name'];
		$tmpFileName = $_FILES['newfile']['name'];
		
		// Nessun file inviato
		if(!$tmpFile || !$tmpFileName) {
			$msg = "<script>document.write(jfbc_nofile_selected);</script>";
			$this->showForms($msg);
			return;
		}
		
		// Controlla se il file  inferiore alla dimensione massima, altrimenti interrompe con errore
		$tmpFileSize = $_FILES['newfile']['size'];
		$allowedFileSize = $this->config->get('maxfilesize') * 1024 * 1024; // MB->Bytes
		if($tmpFileSize > $allowedFileSize) {
			$msg = "<script>document.write(jfbc_size_error);</script> Max {$this->config->get('maxfilesize')} MB.";
			$this->showForms($msg);
			return;
		}
		
		// Controlla se il file ha una estensione ammessa, altrimenti interrompe con errore
		$disallowedExtensions = explode(',', $this->config->get('disallowed_extensions')); 
		$tmpFileExtension = array_pop(explode('.', $tmpFileName));
		if(in_array($tmpFileExtension, $disallowedExtensions)) {
			$msg = "<script>document.write(jfbc_ext_error);document.write('" . $this->config->get('disallowed_extensions') . "');</script>.";
			$this->showForms($msg);
			return;
		}
				
		// Controlla se la cartella target esiste altrimenti provvede
		if(!is_dir($this->cacheFolder)) {
			JFolder::create($this->cacheFolder);
		}
		
		// Controlla se la cartella target  scrivibile, altrimenti prova a settare i chmod, altrimenti interrompe con errore
		if(!is_writable($this->cacheFolder)) {
			// prova a amodificare i permessi
			try {
				if(!chmod($this->cacheFolder, 0775)) {
					throw new Exception('<script>document.write(jfbc_dir_writable);</script>');
				}
			} catch(Exception $e) {
				$msg = $e->getMessage();
				$this->showForms($msg);
				return;
			}
		}
		 
		// Effettua la move uploaded file
		if(!move_uploaded_file($tmpFile, $this->cacheFolder . $tmpFileName)) {
			$msg = "<script>document.write(jfbc_upload_error);</script>";
			$this->showForms($msg);
			return;
		}
	 
		// Richiede la creazione di un hash filename per il thumbnail con format force a png
		$hashedFileName = $this->generaHash($tmpFileName, $this->from);
		
		// Se esiste il file ripuliamo adesso e sovrascriviamo; il file name  sempre univoco per utente
		if(file_exists($this->cacheFolder . $hashedFileName)) {
			unlink($this->cacheFolder . $hashedFileName);
		}
		 
		// Rinomina il file caricato in base all'hash filename
		if(!rename($this->cacheFolder . $tmpFileName, $this->cacheFolder . $hashedFileName)) {
			$msg = "<script>document.write(jfbc_rename_error);</script>";
			$this->showForms($msg);
			return;
		}
		 
		// Inserisce il MSGFILE nel database per effettuare l'effettivo send al destinatario
		if(!$this->storeDBMessage($tmpFileName)) {
			$msg = "<script>document.write(jfbc_sendmsgfile_error);</script>";
			$this->showForms($msg);
			return;
		}
		
		// Richiama la showForms con user message 
		$msg = '<script>document.write(jfbc_success_fileupload);</script>';
		$this->showForms($msg);
	}

	/**
	 * Effettua l'upload del file secondo lo stream wrapper php://input
	 * da XHR2 client e HTTP header
	 * @access public
	 * @return void 
	 */
	public function doUploadXHR2() { 
        if (array_key_exists('HTTP_X_FILE_NAME', $_SERVER) && array_key_exists('CONTENT_LENGTH', $_SERVER)) {
            $tmpFileName = $_SERVER['HTTP_X_FILE_NAME'];
            $tmpFileSize = $_SERVER['CONTENT_LENGTH'];
            $this->to = $_SERVER['HTTP_X_TO_USER'];
            $this->senderName = $_SERVER['HTTP_X_FROM_USER_NAME'];
            $this->receiverName = $_SERVER['HTTP_X_TO_USER_NAME'];
        }; 
     
		// Nessun file inviato
		if(!$tmpFileName) {
			echo false;
			return;
		}
		
		// Controlla se il file  inferiore alla dimensione massima, altrimenti interrompe con errore 
		$allowedFileSize = $this->config->get('maxfilesize') * 1024 * 1024; // MB->Bytes
		if($tmpFileSize > $allowedFileSize) {
			echo false;
			return;
		}
		 
		// Controlla se il file ha una estensione ammessa, altrimenti interrompe con errore
		$disallowedExtensions = explode(',', $this->config->get('disallowed_extensions')); 
		$tmpFileExtension = array_pop(explode('.', $tmpFileName));
		if(in_array($tmpFileExtension, $disallowedExtensions)) {
			echo false;
			return;
		}
		
		// Controlla se la cartella target esiste altrimenti provvede
		if(!is_dir($this->cacheFolder)) {
			JFolder::create($this->cacheFolder);
		}
		
		// Controlla se la cartella target  scrivibile, altrimenti prova a settare i chmod, altrimenti interrompe con errore
		if(!is_writable($this->cacheFolder)) {
			// prova a amodificare i permessi 
			if(!chmod($this->cacheFolder, 0775)) {
				echo false;
				return;
			} 
		}
		
		// Storing del file inviato in asincrono
		file_put_contents(
            $this->cacheFolder . $tmpFileName,
            file_get_contents("php://input")
        );
        
		// Richiede la creazione di un hash filename per il thumbnail con format force a png
		$hashedFileName = $this->generaHash($tmpFileName, $this->from);
		
		// Se esiste il file ripuliamo adesso e sovrascriviamo; il file name  sempre univoco per utente
		if(file_exists($this->cacheFolder . $hashedFileName)) {
			unlink($this->cacheFolder . $hashedFileName);
		}
		 
		// Rinomina il file caricato in base all'hash filename
		if(!rename($this->cacheFolder . $tmpFileName, $this->cacheFolder . $hashedFileName)) {
			echo false;
			return;
		}
		 
		// Inserisce il MSGFILE nel database per effettuare l'effettivo send al destinatario
		if(!$this->storeDBMessage($tmpFileName)) {
			echo false;
			return;
		} 
        echo true; 
	}
	
	/**
	 * Effettua il download del file inviato al ricevente da parte
	 * del ricevente stesso risalendo all'hash del file da scaricare 
	 * @return void
	 */
	public function doDownload() { 
		$idMessage = JRequest::getInt('idMessage', 0);
		$idUserConversation = JRequest::getVar('from', null);
		 
		// Recupera il nome del file da database/sessione da ID
		try {
			$query = "SELECT #__fbchat.session_id_from AS" . $this->DBO->quoteName('from') . ", #__fbchat.message FROM #__fbchat WHERE id = " . (int)$idMessage;
			$this->DBO->setQuery($query);
			$resultInfo = $this->DBO->loadObject();
			// Se non  stato trovato nel DB cerchiamo in sessione
			if(!$resultInfo) {
				// Recuperiamo i messaggi della specifica conversazione
				$conversationArray = $_SESSION['jfbcchat_user_' . $idUserConversation];
				// Ciclo su tutti i messaggi della conversazione
				foreach ($conversationArray as $message) {
					if($message['id'] == $idMessage) {
						$resultInfo = new stdClass();
						$resultInfo->from = $message['from'];
						$resultInfo->message = $message['message'];
						break;
					} 
				}
				if(!$resultInfo) {
					throw new Exception('jfbc_error_notfound_file');
				}
			}
			$fileName = $this->generaHash($resultInfo->message, $resultInfo->from);
			$filePath = $this->cacheFolder . $fileName;
			
			// Controllo esistenza file
			if(!file_exists($filePath)) {
				throw new Exception('jfbc_error_deleted_file');
			}
		} catch (Exception $e) {
			// JS inject
			$baseUri = JURI::base(); 
			$language = $this->config->get('language');  
			echo '<script src="' . $baseUri .'components/com_jfbchat/languages/' . $language . '" charset="utf-8"></script>';
			echo '<script>alert(' . $e->getMessage() . ');window.history.go(-1);</script>';
			exit();
		} 
		
		$fsize = @filesize ( $filePath );
		$mod_date = date ( 'r', filemtime ( $filePath ) ); 
		$cont_dis = 'attachment';
		$mimeType = $this->detectMimeType ( $fileName );
		
		// required for IE, otherwise Content-disposition is ignored
		if (ini_get ( 'zlib.output_compression' )) {
			ini_set ( 'zlib.output_compression', 'Off' );
		}
		header ( "Pragma: public" );
		header ( "Cache-Control: must-revalidate, post-check=0, pre-check=0" );
		header ( "Expires: 0" );
		header ( "Content-Transfer-Encoding: binary" );
		header ( 'Content-Disposition:' . $cont_dis . ';' . ' filename="' . $resultInfo->message . '";' . ' modification-date="' . $mod_date . '";' . ' size=' . $fsize . ';' ); //RFC2183
		header ( "Content-Type: " . $mimeType ); // MIME type
		header ( "Content-Length: " . $fsize );
		if (! ini_get ( 'safe_mode' )) { // set_time_limit doesn't work in safe mode
			@set_time_limit ( 0 );
		}
		// No encoding - we aren't using compression... (RFC1945)
		//header("Content-Encoding: none");
		//header("Vary: none");
		$downloadStatus = $this->readFileChunked ( $filePath );
		
		// Al raggiungimento dell'effettivo download si aggiorna lo status update
		if($downloadStatus) {
			$query = "UPDATE #__fbchat SET status=1 WHERE id = " . (int)$idMessage;
			$this->DBO->setQuery($query); 
			$this->DBO->execute();
		} 
		exit();
	}

	/**
	 * Class constructor
	 * @access public
	 * @param int $from
	 * @param int $to
	 * @return Object &
	 */
	public function __construct($from, $to, $senderName, $receiverName) {
		$this->DBO = JFactory::getDBO();
		$this->config = &JComponentHelper::getParams ( 'com_jfbchat' ); 
		$this->from = $from;
		$this->to = $to;
		$this->senderName = $senderName;
		$this->receiverName = $receiverName;
		$this->cacheFolder = 'components/com_jfbchat/cache/';
	}
} 
?>