<?php
//namespace components\com_jfbchat\models; 
/** 
 * @package FBCHAT::components::com_jfbchat
 * @subpackage models
 * @author 2Punti - Marco Biagioni 
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html  
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
  
/**
 * Classe che gestisce il garbage collector dei messaggi obsoleti nel database 
 * @package FBCHAT::components::com_jfbchat
 * @subpackage models 
 * @since 1.0
 */
class jfbcSender {
	 
	/**
	 * Session Object
	 * @access private
	 * @var Object &
	 */
	private $session;
	  
	/**
	 * Memorizza un reference all'oggetto database
	 * @access private
	 * @var Object &
	 */
	private $DBO;
	
	/**
	 * Inserisce/aggiorna lo status impostato dall'utente
	 * @access public
	 * @return int
	 */
	public function insertStatus(&$status) {
		$sql = ("INSERT INTO #__fbchat_status (session_id, status) VALUES (" .
				$this->DBO->Quote($this->session->session_id) . "," .
				$this->DBO->Quote($status) . ") " .
				"\n ON DUPLICATE KEY UPDATE status = " . $this->DBO->Quote($status));
		$this->DBO->setQuery($sql);
		$result = $this->DBO->execute();
		 
		if($result)
			return 1;
	}
	
	/**
	 * Inserisce/aggiorna lo status message impostato dall'utente
	 * @access public
	 * @return int
	 */
	public function insertStatusMsg(&$statusmessage) { 
		$sql = ("INSERT INTO #__fbchat_status (session_id, message) VALUES (" .
				$this->DBO->Quote($this->session->session_id) . ","  . 
				$this->DBO->Quote($statusmessage) . ") " .
				"\n ON DUPLICATE KEY UPDATE message = ".$this->DBO->Quote($statusmessage));
		$this->DBO->setQuery($sql);
		$result = $this->DBO->execute();
		
		if($result)
			return 1;
	}
	
	/**
	 * Inserisce/aggiorna lo status message impostato dall'utente
	 * @param string $updateField
	 * @access public
	 * @return int
	 */
	public function insertSkypeFields(&$updateField) {
		// Dynamic datasent
		$dataSent = JRequest::getvar('datasent', false);
		if($dataSent !== false) {
			$sql = ("INSERT INTO #__fbchat_status (session_id, " .$this->DBO->quoteName($updateField) . ") VALUES (" . 
					$this->DBO->Quote($this->session->session_id) . ","  .
					$this->DBO->Quote($dataSent) . ") " .
					"\n ON DUPLICATE KEY UPDATE " .$this->DBO->quoteName($updateField) . " = " . $this->DBO->Quote($dataSent));
			$this->DBO->setQuery($sql);
			$result = $this->DBO->execute();
		
			if($result)
				return 1; 
		}
	}
	
	/**
	 * Inserisce/aggiorna lo status name impostato dall'utente
	 * @access public
	 * @return int
	 */
	public function insertOverrideName(&$name) {
		// Degrade DB NULL
		if($name == '-') {
			$name = 'NULL';
		} else {
			$name = $this->DBO->Quote($name);
		}
		$sql = ("INSERT INTO #__fbchat_status (session_id, override_name) VALUES (" .
				$this->DBO->Quote($this->session->session_id) . ","  .
				 $name . ") " .
				"\n ON DUPLICATE KEY UPDATE override_name = ". $name );
		$this->DBO->setQuery($sql);
		$result = $this->DBO->execute();
	
		if($result)
			return 1;
	}
	
	/**
	 * Inserisce i messaggi inviati
	 * @access public
	 * @param string $message&
	 * @param int $to
	 * @param string $fromName
	 * @param string $toName
	 * @return int
	 */
	public function insertMessage(&$message, $to, $senderName, $receiverName) {
		if ($this->session->session_id) {
			$sql = 	"INSERT INTO #__fbchat " .
					"\n (" . $this->DBO->quoteName('session_id_from') . "," . 
					"\n " . $this->DBO->quoteName('session_id_to') . "," .
					"\n " . $this->DBO->quoteName('message') . "," .
					"\n " . $this->DBO->quoteName('sent') . "," .
					"\n " . $this->DBO->quoteName('read') . "," .
					"\n " . $this->DBO->quoteName('sender_name') . "," .
					"\n " . $this->DBO->quoteName('receiver_name') . ") VALUES (" .
					$this->DBO->Quote($this->session->session_id) . "," . 
					$this->DBO->Quote($to) . "," . 
					$this->DBO->Quote($message) . ", UNIX_TIMESTAMP(NOW()), 0, " .
					$this->DBO->Quote($senderName) . "," .
					$this->DBO->Quote($receiverName) . ")";
			$this->DBO->setQuery($sql);
			$this->DBO->execute();
		
			if (empty($_SESSION['jfbcchat_user_'.$to])) {
				$_SESSION['jfbcchat_user_'.$to] = array();
			}
			//Memorizziamo in sessione locale mittente il messaggio inviato al to destinatario
			$_SESSION['jfbcchat_user_'.$to][] = array(	"id" => $this->DBO->insertid(), 
														"from" => $to, 
														"message" => $message, 
														"self" => 1, 
														"old" => 1) ;
				
			return $this->DBO->insertid(); 
		}
	}
	
	/**
	 * Inserisce nella table preposta il lamessage inviato dagli utenti
	 * @access public
	 * @param $data array& 
	 * @return mixed L'id del message inserted o false in caso di errori
	 */
	public function insertLamessage(&$data) {
		// Lazy loading pattern
		jimport('joomla.mail.helper');
		$connectedUser = JFactory::getUser();
 		
		// Richiesta una validazione lato server per indirizzo valido e campi non vuoti
     	if ($data['email'] && !JMailHelper::isEmailAddress($data['email'])) {
     		return false;
     	}
     	if (!$data['name']) {
     		return false;
     	}
     	if (!$data['message']) {
     		return false;
     	}
      
		if ($this->session->session_id) {
			$genericObject = new stdClass();
			$genericObject->name = $data['name'];
			$genericObject->email = $data['email'];
			$genericObject->message = $data['message'];
			$genericObject->sentdate = date('Y-m-d', time());
			$genericObject->userid = (int)$connectedUser->id;
			 
			if($this->DBO->insertObject('#__fbchat_lamessages', $genericObject, 'id')) {
				return $this->DBO->insertid(); 
			}
			return false;
		}
		return false;
	}
	
	/**
	 * Aggiorna istantaneamente in sessione
	 * @access public
	 * @return void
	 */
	public function resfreshActiveChatBoxes(&$sessionActiveChatBoxes) {
		$_SESSION['jfbcchat_sessionvars']['activeChatboxes'] = $sessionActiveChatBoxes;
	}
	
	/**
	 * Setta i parametri di configurazione nelle private properties 
	 * @access public
	 * @param Object& $session
	 * @return Object&
	 */
	public function __construct(&$session) {
		/** 
		 * Inizializzazione oggetto 
		 */
		$this->DBO = JFactory::getDBO (); 
		$this->session = &$session;
	}
} 