<?php
//namespace components\com_jfbchat\models; 
/** 
 * @package FBCHAT::SUGGESTIONS::components::com_jfbchat
 * @subpackage models
 * @author 2Punti - Marco Biagioni      
 * @copyright (C) 2012 - 2PUNTI SRL
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html  
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.filesystem.file');
/**
 * Permette di scegliere da una lista di risposte predefinite con cui
 * rispondere agli interventi dei customers da parte degli agenti
 * @package FBCHAT::SUGGESTIONS::components::com_jfbchat
 * @subpackage models
 * @since 1.0
 */ 
class jfbcSuggestions {
	/**
	 * DB object connector
	 * @access private
	 * @var Object
	 */
	private $DBO;
	
	/**
	 * Component configuration object
	 * @access private
	 * @var Object
	 */
	private $config;

	/**
	 * Recupera i records dalla DB Table
	 * @access private 
	 * @return Object[] &
	 */
	private function &getRecords() {
		$query = "SELECT suggestion FROM #__fbchat_suggestions" .
				 "\n WHERE " . $this->DBO->quoteName('published') . " = 1";
		$this->DBO->setQuery($query);
		$results = $this->DBO->loadObjectList();
		
		return $results;
	}

	/**
	 * Mostra la visualizzazione dei records dei suggerimenti testuali 
	 * e inietta la JS App che permette di inserire il testo cliccato nel parent
	 * iframe contenteditable div per essere inviato in chat
	 * @access public 
	 * @return void 
	 */
	public function showSuggestions() {
		// Get base URI
		$baseUri = JURI::base(); 
		
		// Config params get
		$language = $this->config->get('language');
		$template = $this->config->get('template'); 
		
		// Get records suggestions from DB
		$liList = null;
		$suggestions = $this->getRecords();
		
		if(is_array($suggestions) && count($suggestions)) {
			foreach ($suggestions as $suggestion) {
				$liList .= '<li class="jfbc_suggestion_item">' . $suggestion->suggestion . '</li>';
			}
		}
		
		$uploadForm = <<<UPLOADFORM
		<script type="text/javascript" src="{$baseUri}components/com_jfbchat/languages/$language" charset="utf-8"></script>
		<script type="text/javascript" src="{$baseUri}components/com_jfbchat/js/jquery.js"></script>
		<script type="text/javascript" src="{$baseUri}components/com_jfbchat/js/suggestions.js"></script>
		<link type="text/css" rel="stylesheet" href="{$baseUri}components/com_jfbchat/css/$template"/> 
		<div id="jfbc_suggestions">
                <ul id="jfbc_suggestionsList">
					$liList
				</ul> 
     	</div>
UPLOADFORM;
		 echo $uploadForm; 
	}

	/**
	 * Class constructor
	 * @access public
	 * @return Object &
	 */
	public function __construct() {
		$this->DBO = JFactory::getDBO();
		$this->config = &JComponentHelper::getParams ( 'com_jfbchat' ); 
	}
}
?>